#include <amdis/AMDiS.hpp>
#include <amdis/LocalOperators.hpp>
#include <amdis/ProblemStat.hpp>

using namespace AMDiS;

using Grid = Dune::YaspGrid<2>;

template <class T>
struct Param
    : DefaultBasisCreator<Grid, Impl::LagrangePreBasisCreator<1,1>, T>
{};

template <class T>
void test()
{
  ProblemStat<Param<T>> prob("ellipt");
  prob.initialize(INIT_ALL);
  prob.boundaryManager()->setBoxBoundary({1,1,2,2});

  prob.addMatrixOperator(sot(T(1)), 0, 0);
  prob.addVectorOperator(zot(T(1)), 0);
  prob.addDirichletBC(BoundaryType{1}, 0,0, T(0));
}

int main(int argc, char** argv)
{
  Environment env(argc, argv);

  test<float>();
  test<double>();
  test<long double>();

  return 0;
}
